=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2011-06-27 19:41:59 +0000
+++ loggerhead/controllers/download_ui.py	2011-06-28 15:55:36 +0000
@@ -32,11 +32,11 @@
 
 
 class DownloadUI (TemplatedBranchView):
-    
+
     def encode_filename(self, filename):
-        
+
         return urllib.quote(filename.encode('utf-8'))
-    
+
     def get_args(self, environ):
         args = []
         while True:
@@ -44,27 +44,21 @@
             if arg is None:
                 break
             args.append(arg)
-            
         return args
 
     def __call__(self, environ, start_response):
         # /download/<rev_id>/<file_id>/[filename]
-
         h = self._history
-        
         args = self.get_args(environ)
-
         if len(args) < 2:
             raise httpexceptions.HTTPMovedPermanently(
                 self._branch.absolute_url('/changes'))
-
         revid = h.fix_revid(args[0])
         file_id = args[1]
         path, filename, content = h.get_file(file_id, revid)
         mime_type, encoding = mimetypes.guess_type(filename)
         if mime_type is None:
             mime_type = 'application/octet-stream'
-
         self.log.info('/download %s @ %s (%d bytes)',
                       path,
                       h.get_revno(revid),
@@ -79,36 +73,28 @@
         start_response('200 OK', headers)
         return [content]
 
+
 class DownloadTarballUI(DownloadUI):
-     
+
     def __call__(self, environ, start_response):
         """Stream a tarball from a bazaar branch."""
-        
-        #Tried to re-use code from downloadui, not very successful
-        
-        format = ".tar.gz"
-        
+        # Tried to re-use code from downloadui, not very successful
+        format = "tgz"
         history = self._history
-        
         self.args = self.get_args(environ)
-        
         if len(self.args):
             revid = history.fix_revid(self.args[0])
         else:
             revid = self.get_revid()
-            
         if self._branch.export_tarballs:
-            
-            encoded_filename = self.encode_filename("branch" + format)
-            
+            root = 'branch'
+            encoded_filename = self.encode_filename(root + format)
             headers = [
                 ('Content-Type', 'application/octet-stream'),
                 ('Content-Disposition',
                  "attachment; filename*=utf-8''%s" % (encoded_filename,)),
                 ]
-            
             start_response('200 OK', headers)
-            
-            return export_archive(history, revid, format)
+            return export_archive(history, root, revid, format)
         else:
             raise httpexceptions.HTTPSeeOther('/')

=== modified file 'loggerhead/exporter.py'
--- loggerhead/exporter.py	2011-06-08 21:27:57 +0000
+++ loggerhead/exporter.py	2011-06-28 15:55:36 +0000
@@ -1,40 +1,46 @@
+# Copyright (C) 2011 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
 """Exports an archive from a bazaar branch"""
 
 from bzrlib.export import get_export_generator
 
+
 class ExporterFileObject(object):
-    
+
     def __init__(self):
         self._buffer = []
-        
-    def write(self, str):
-        self._buffer.append(str)
-        
+
+    def write(self, s):
+        self._buffer.append(s)
+
     def get_buffer(self):
         try:
             return ''.join(self._buffer)
         finally:
             self._buffer = []
-        
-def export_archive(history, revid, format=".tar.gz"):
+
+
+def export_archive(history, root, revid, format=".tar.gz"):
     """Export tree contents to an archive
 
     :param history: Instance of history to export
+    :param root: Root location inside the archive.
     :param revid: Revision to export
     :param format: Format of the archive
     """
-    
     fileobj = ExporterFileObject()
-    
     tree = history._branch.repository.revision_tree(revid)
-    
-    for _ in get_export_generator(tree=tree, fileobj=fileobj, format=format):
-        
+    for _ in get_export_generator(tree=tree, root=root, fileobj=fileobj, format=format):
         yield fileobj.get_buffer()
-    
     # Might have additonal contents written
-        
     yield fileobj.get_buffer()
-
-    
-        
\ No newline at end of file

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2011-06-08 21:27:57 +0000
+++ loggerhead/history.py	2011-06-28 15:55:36 +0000
@@ -761,5 +761,6 @@
             renamed=sorted(reporter.renamed, key=lambda x: x.new_filename),
             removed=sorted(reporter.removed, key=lambda x: x.filename),
             modified=sorted(reporter.modified, key=lambda x: x.filename),
-            text_changes=sorted(reporter.text_changes, key=lambda x: x.filename))
+            text_changes=sorted(reporter.text_changes,
+                                key=lambda x: x.filename))
 

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2011-03-10 03:54:45 +0000
+++ loggerhead/templates/revision.pt	2011-06-28 15:55:36 +0000
@@ -86,7 +86,7 @@
                tal:attributes="href python:url(['/diff', change.revno, history.get_revno(compare_revid)], clear=1)">download diff</a>
            </li>
            <li tal:condition="python:can_export">
-            <a tal:attributes="href python:url(['/tarball', change.revno])">download tarball</a>
+            <a tal:attributes="href python:url(['/tarball', change.revno])">Download tarball</a>
            </li>
           <li id="last"><a tal:attributes="href python:url(['/changes', change.revno]);
                                            title string:view history from revision ${change/revno}"

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2011-06-13 02:16:31 +0000
+++ loggerhead/tests/test_controllers.py	2011-06-28 15:55:36 +0000
@@ -1,5 +1,6 @@
 from cStringIO import StringIO
 import logging
+import tarfile
 
 from paste.httpexceptions import HTTPServerError
 
@@ -12,9 +13,6 @@
 from loggerhead.tests.test_simple import BasicTests
 from loggerhead import util
 
-from os import tmpnam
-from tarfile import is_tarfile
-
 
 class TestInventoryUI(BasicTests):
 
@@ -129,13 +127,18 @@
         self.assertEqual('2', annotated[0].change.revno)
         self.assertEqual('1', annotated[1].change.revno)
 
+
 class TestDownloadTarballUI(BasicTests):
-    
+
+    def setUp(self):
+        super(TestDownloadTarballUI, self).setUp()
+        self.createBranch()
+
     def test_download_tarball(self):
         app = self.setUpLoggerhead()
         res = app.get('/tarball')
-        tmpname = tmpnam()
-        f = open(tmpname, 'w')
+        f = open('tarball', 'w')
         f.write(res)
         f.close()
-        self.failIf(not is_tarfile(tmpname))
+        self.failIf(not tarfile.is_tarfile('tarball'))
+        # Now check the content. TBC

